/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   get_next_line.c                                    :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: vibucho <marvin@42.fr>                     +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2014/11/10 16:18:12 by vibucho           #+#    #+#             */
/*   Updated: 2015/01/05 14:11:45 by vibucho          ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "fdf.h"
#include "libft.h"

static	int	ft_swag(char *tmp, char **line, char **stock)
{
	if (tmp)
	{
		*tmp = 0;
		if (*stock)
			*line = ft_strdup(*stock);
		else
			*line = ft_strdup(tmp);
		if (*(tmp + 1))
			ft_strcpy(*stock, tmp + 1);
		else
			*stock = NULL;
		return (1);
	}
	return (0);
}

static	int ft_yolo(char *tmp, char **stock, char *buff, char **line)
{
	if (tmp)
	{
		*tmp = 0;
		*line = ft_strjoin(*stock, buff);
		free(*stock);
		if (*(tmp + 1))
		{
			*stock = ft_strdup(tmp + 1);
		}
		else
			*stock = NULL;
		return (1);
	}
	tmp = *stock;
	*stock = ft_strjoin(*stock, buff);
	free(tmp);
	return (0);
}

static	int	ft_oklm(int rtn, char *stock)
{
	if (rtn == -1)
		return (-1);
	if (stock == NULL)
		return (0);
	return (1);
}

int			get_next_line(int const fd, char **line)
{
	int				rtn;
	char			*buff;
	static	char	*stock = NULL;
	char			*tmp;

	buff = malloc(sizeof(char) * BUFF_SIZE + 1);
	if (stock)
	{
		tmp = ft_strchr(stock, '\n');
		if (ft_swag(tmp, line, &stock))
			return (1);
	}
	while ((rtn = read(fd, buff, BUFF_SIZE)) > 0)
	{
		buff[rtn] = 0;
		tmp = ft_strchr(buff, '\n');
		if (ft_yolo(tmp, &stock, buff, line))
			return (1);
	}
	if (rtn == -1 || stock == NULL)
		return (ft_oklm(rtn, stock));
	*line = stock;
	stock = NULL;
	return (1);
}
